// Mfc42uCheck.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//
// !!! NOTE !!!  compile with _UNICODE

#include "stdafx.h"
#include "Mfc42uCheck.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B̃AvP[V IuWFNg

CWinApp theApp;

void DisplayMfcDllInfo();

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// MFC ̏яs̃G[̏o
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		wprintf( L"Fatal Error: MFC initialization failed" );
		nRetCode = 1;
	}
	else
	{
		DisplayMfcDllInfo();

		// >>> TEST code
		// !!! NOTE !!!  compile with _UNICODE
		const int RepeatCount = 8;
		const int BufferLength = 16;
		bool success = true;
		DWORD prevHash = 0;
		char buffer[ BufferLength ];
		srand( ::GetTickCount() );
		for( int i=0; i<RepeatCount; i++ )
		{
			for( int j=0; j<BufferLength; j++ ) buffer[j] = rand();	// fill buffer with random values
			strcpy( buffer, "TestString" );	// copy static string to buffer
			DWORD hashValue = HashKey<LPCSTR>( buffer );	// calcurate hash value of ANSI string
			printf( "Hash value of [%s] is 0x%08X\n", buffer, hashValue );
			if( prevHash == 0 ) prevHash = hashValue;
			else if( prevHash != hashValue ) success = false;
		}
		// <<< TEST code
		if( success )
			MessageBox( NULL, L"MFC42U.DLLɂANSĨnbVl͐łB", L"Mfc42uCheck", MB_OK|MB_ICONINFORMATION );
		else
			MessageBox( NULL, L"MFC42U.DLLɂANSĨnbVlɈُ킪܂B", L"Mfc42uCheck", MB_OK|MB_ICONERROR );
	}

	return nRetCode;
}

void DisplayMfcDllInfo()
{
	char* vibuf = NULL;
	WCHAR path[MAX_PATH];
	::GetModuleFileName( ::GetModuleHandle(L"MFC42U.DLL"), path, MAX_PATH );
	wprintf( L"MFC42U.DLL file path = \"%s\"\n", path );
	DWORD size = ::GetFileVersionInfoSize( path, NULL ); 
	vibuf = new char[(size_t)size];
	::GetFileVersionInfo( path, NULL, size, vibuf );
	VS_FIXEDFILEINFO* ptr;
	UINT len;
	::VerQueryValue( vibuf, L"\\", (void**)&ptr, &len );
	wprintf( L"MFC42U.DLL version = \"%d.%d.%d.%d\"\n",
		HIWORD(ptr->dwFileVersionMS), LOWORD(ptr->dwFileVersionMS),
		HIWORD(ptr->dwFileVersionLS), LOWORD(ptr->dwFileVersionLS) );
	delete[] vibuf;
}
